﻿local FSwapper3 = LibStub("AceAddon-3.0"):GetAddon("FSwapper3");
local L = LibStub("AceLocale-3.0"):GetLocale("FSwapper3", true);


FSwapper3.FS3GUI = {};
local FS3GUI = FSwapper3.FS3GUI;

local TabFrame;

function FS3GUI:DoInit()

end

function FS3GUI:Toggle()
	if (TabFrame:IsShown()) then
		HideUIPanel(TabFrame);
	else
		ShowUIPanel(TabFrame);
	end
end

--[[
FSwapper3.FS3GUI = CreateFrame("Frame", nil, UIParent);
FSwapper3.FS3GUI.opentab = 1; -- 1 Weapon, 2 Options, 3 Auto Loot
FSwapper3.FS3GUI_Title = FSwapper3.FS3GUI:CreateFontString("$parent_Title","ARTWORK","GameFontNormal");
FSwapper3.FS3GUI_WeaponBtn = CreateFrame("Button", nil, FSwapper3.FS3GUI, "UIPanelButtonTemplate");
FSwapper3.FS3GUI_OptionsBtn = CreateFrame("Button", nil, FSwapper3.FS3GUI, "UIPanelButtonTemplate");
FSwapper3.FS3GUI_AutoLootBtn = CreateFrame("Button", nil, FSwapper3.FS3GUI, "UIPanelButtonTemplate");
FSwapper3.FS3GUI_EnableBtn = CreateFrame("Button", nil, FSwapper3.FS3GUI, "UIPanelButtonTemplate");
FSwapper3.FS3GUI_CloseBtn = CreateFrame("Button", nil, FSwapper3.FS3GUI, "UIPanelCloseButton");

FSwapper3.FS3GUI_WeaponTab = CreateFrame("Frame", nil, FSwapper3.FS3GUI);
FSwapper3.FS3GUI_WeaponTab_MainHandLabel = FSwapper3.FS3GUI_WeaponTab:CreateFontString("$parent_MainHandLabel","BACKGROUND","GameFontNormal");
FSwapper3.FS3GUI_WeaponTab_MainHandText = FSwapper3.FS3GUI_WeaponTab:CreateFontString("$parent_MainHandText","BACKGROUND","GameFontNormal");
FSwapper3.FS3GUI_WeaponTab_MainHandTip = CreateFrame("Frame", nil, FSwapper3.FS3GUI_WeaponTab);
FSwapper3.FS3GUI_WeaponTab_OffHandLabel = FSwapper3.FS3GUI_WeaponTab:CreateFontString("$parent_OffHandLabel","BACKGROUND","GameFontNormal");
FSwapper3.FS3GUI_WeaponTab_OffHandText = FSwapper3.FS3GUI_WeaponTab:CreateFontString("$parent_OffHandText","BACKGROUND","GameFontNormal");
FSwapper3.FS3GUI_WeaponTab_OffHandTip = CreateFrame("Frame", nil, FSwapper3.FS3GUI_WeaponTab);
FSwapper3.FS3GUI_WeaponTab_PoleLabel = FSwapper3.FS3GUI_WeaponTab:CreateFontString("$parent_PoleLabel","BACKGROUND","GameFontNormal");
FSwapper3.FS3GUI_WeaponTab_PoleText = FSwapper3.FS3GUI_WeaponTab:CreateFontString("$parent_PoleText","BACKGROUND","GameFontNormal");
FSwapper3.FS3GUI_WeaponTab_PoleTip = CreateFrame("Frame", nil, FSwapper3.FS3GUI_WeaponTab);

-- GUI Functions
function FSwapper3.FS3GUI:DoInit()
	local TempFrameHeight, EnableBtnWidth, BtnHeight, BtnWidth, LineBtnsX = 5, 0, 0, 0, 0;
	FSwapper3.FS3GUI:SetFrameStrata("FULLSCREEN_DIALOG");
	FSwapper3.FS3GUI:SetWidth(350);
	FSwapper3.FS3GUI:SetAttribute("UIPanelLayout-defined", true);
	FSwapper3.FS3GUI:SetAttribute("UIPanelLayout-enabled", true);
	FSwapper3.FS3GUI:SetAttribute("UIPanelLayout-area", "left");
	FSwapper3.FS3GUI:SetAttribute("UIPanelLayout-pushable", 5);
	FSwapper3.FS3GUI:SetAttribute("UIPanelLayout-width", 350);
	FSwapper3.FS3GUI:SetAttribute("UIPanelLayout-whileDead", true);
	FSwapper3.FS3GUI:SetBackdrop({
			bgFile="Interface\\DialogFrame\\UI-DialogBox-Background",
			edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
			tile = true, tileSize = 32, edgeSize = 32, 
			insets = { left = 8, right = 8, top = 8, bottom = 8 }
		});
	FSwapper3.FS3GUI:SetBackdropColor(0,0,0,1);
	FSwapper3.FS3GUI:EnableMouse();
	FSwapper3.FS3GUI:SetScript("OnShow", function()
			FSwapper3.FS3GUI:ShowTab();
		end);
	HideUIPanel(FSwapper3.FS3GUI);

	FSwapper3.FS3GUI_Title:SetText("FSwapper3 v" .. FSwapper3.FS3VERSION);
	TempFrameHeight = 13; -- 8+5
	FSwapper3.FS3GUI_Title:SetPoint("TOP",FSwapper3.FS3GUI,"TOP",0,-TempFrameHeight);
	FSwapper3.FS3GUI_Title:SetWidth(326);

	TempFrameHeight = 5 + TempFrameHeight + FSwapper3.FS3GUI_Title:GetStringHeight();
	
	FSwapper3.FS3GUI_EnableBtn:SetText(ENABLE);
	FSwapper3.FS3GUI_EnableBtn:SetPoint("TOPRIGHT",FSwapper3.FS3GUI,"TOPRIGHT",-13,-TempFrameHeight);
	EnableBtnWidth = FSwapper3.FS3GUI_EnableBtn:GetTextWidth() + 20;
	BtnHeight = FSwapper3.FS3GUI_EnableBtn:GetTextHeight() + 10;
	FSwapper3.FS3GUI_EnableBtn:SetWidth(EnableBtnWidth);
	FSwapper3.FS3GUI_EnableBtn:SetHeight(BtnHeight);
	FSwapper3.FS3GUI_EnableBtn:SetScript("OnClick", function (self, button)
			if (button == "LeftButton") then
				FSwapper3:SetEnable();
				FSwapper3.FS3GUI:UpdateTab();
			end
		end)
		
	LineBtnsX = 13;

	FSwapper3.FS3GUI_WeaponBtn:SetText(ENCHSLOT_WEAPON);
	BtnWidth = FSwapper3.FS3GUI_WeaponBtn:GetTextWidth() + 20;
	FSwapper3.FS3GUI_WeaponBtn:SetWidth(BtnWidth);
	FSwapper3.FS3GUI_WeaponBtn:SetHeight(BtnHeight);
	if ((LineBtnsX + BtnWidth + 5) > (350 - 13 - EnableBtnWidth)) then
		LineBtnsX = 13;
		TempFrameHeight = TempFrameHeight + BtnHeight + 5;
	end
	FSwapper3.FS3GUI_WeaponBtn:SetPoint("TOPLEFT",FSwapper3.FS3GUI,"TOPLEFT",LineBtnsX,-TempFrameHeight);
	LineBtnsX = LineBtnsX + BtnWidth + 5;
	FSwapper3.FS3GUI_WeaponBtn:SetScript("OnClick", function (self, button)
			if (button == "LeftButton") then
				FSwapper3.FS3GUI:ShowTab(1);
			end
		end)

	FSwapper3.FS3GUI_OptionsBtn:SetText(GAMEOPTIONS_MENU);
	BtnWidth = FSwapper3.FS3GUI_OptionsBtn:GetTextWidth() + 20;
	FSwapper3.FS3GUI_OptionsBtn:SetWidth(BtnWidth);
	FSwapper3.FS3GUI_OptionsBtn:SetHeight(BtnHeight);
	if ((LineBtnsX + BtnWidth + 5) > (350 - 13 - EnableBtnWidth)) then
		LineBtnsX = 13;
		TempFrameHeight = TempFrameHeight + BtnHeight + 5;
	end
	FSwapper3.FS3GUI_OptionsBtn:SetPoint("TOPLEFT",FSwapper3.FS3GUI,"TOPLEFT",LineBtnsX,-TempFrameHeight);
	LineBtnsX = LineBtnsX + BtnWidth + 5;
	FSwapper3.FS3GUI_OptionsBtn:SetScript("OnClick", function (self, button)
			if (button == "LeftButton") then
				FSwapper3.FS3GUI:ShowTab(2);
			end
		end)
		
	FSwapper3.FS3GUI_AutoLootBtn:SetText(AUTO_LOOT_DEFAULT_TEXT);
	BtnWidth = FSwapper3.FS3GUI_AutoLootBtn:GetTextWidth() + 20;
	FSwapper3.FS3GUI_AutoLootBtn:SetWidth(BtnWidth);
	FSwapper3.FS3GUI_AutoLootBtn:SetHeight(BtnHeight);
	if ((LineBtnsX + BtnWidth + 5) > (350 - 13 - EnableBtnWidth)) then
		LineBtnsX = 13;
		TempFrameHeight = TempFrameHeight + BtnHeight + 5;
	end
	FSwapper3.FS3GUI_AutoLootBtn:SetPoint("TOPLEFT",FSwapper3.FS3GUI,"TOPLEFT",LineBtnsX,-TempFrameHeight);
	LineBtnsX = LineBtnsX + BtnWidth + 5;
	FSwapper3.FS3GUI_AutoLootBtn:SetScript("OnClick", function (self, button)
			if (button == "LeftButton") then
				FSwapper3.FS3GUI:ShowTab(3);
			end
		end)

	TempFrameHeight = 13 + TempFrameHeight + BtnHeight;
	FSwapper3.FS3GUI:SetHeight(TempFrameHeight);

	FSwapper3.FS3GUI_CloseBtn:SetPoint("TOPRIGHT", FSwapper3.FS3GUI, "TOPRIGHT", -4, -4);
	
	FSwapper3.FS3GUI_WeaponTab:DoInit();
	--FS3GUI_OptionsTab:DoInit();
end

function FSwapper3.FS3GUI:ShowIt()
	if (FSwapper3.FS3GUI:IsShown()) then
		HideUIPanel(FSwapper3.FS3GUI);
	else
		ShowUIPanel(FSwapper3.FS3GUI);
	end
end

function FSwapper3.FS3GUI:ShowTab(tab)
	if (tab ~= nil) then
		FSwapper3.FS3GUI.opentab = tab;
	end
	if (FSwapper3.FS3GUI.opentab == 1) then
		FSwapper3.FS3GUI_WeaponBtn:SetButtonState("PUSHED", true);
		FSwapper3.FS3GUI_OptionsBtn:SetButtonState("NORMAL");
		FSwapper3.FS3GUI_AutoLootBtn:SetButtonState("NORMAL");
		FSwapper3.FS3GUI:UpdateTab(1);
		FSwapper3.FS3GUI_WeaponTab:Show();
--		FSwapper3.FS3GUI_OptionsTab:Hide();
--		FSwapper3.FS3GUI_AutLootTab:Hide();
	elseif (FSwapper3.FS3GUI.opentab == 2) then
		FSwapper3.FS3GUI_WeaponBtn:SetButtonState("NORMAL");
		FSwapper3.FS3GUI_OptionsBtn:SetButtonState("PUSHED", true);
		FSwapper3.FS3GUI_AutoLootBtn:SetButtonState("NORMAL");
		FSwapper3.FS3GUI:UpdateTab(2);
		FSwapper3.FS3GUI_WeaponTab:Hide();
--		FSwapper3.FS3GUI_OptionsTab:Show();
--		FSwapper3.FS3GUI_AutLootTab:Hide();
	elseif (FSwapper3.FS3GUI.opentab == 3) then
		FSwapper3.FS3GUI_WeaponBtn:SetButtonState("NORMAL");
		FSwapper3.FS3GUI_OptionsBtn:SetButtonState("NORMAL");
		FSwapper3.FS3GUI_AutoLootBtn:SetButtonState("PUSHED", true);
		FSwapper3.FS3GUI:UpdateTab(3);
		FSwapper3.FS3GUI_WeaponTab:Hide();
--		FSwapper3.FS3GUI_OptionsTab:Hide();
--		FSwapper3.FS3GUI_AutLootTab:Show();
	else
	end
end

function FSwapper3.FS3GUI:UpdateTab(tab)
	if (tab == nil) then
		tab = FSwapper3.FS3GUI.opentab;
	elseif (tab ~= FSwapper3.FS3GUI.opentab) then
		return;
	end
	
	if (FSwapper3.db.char.Enable) then
		FSwapper3.FS3GUI_EnableBtn:SetButtonState("PUSHED", true);
	else
		FSwapper3.FS3GUI_EnableBtn:SetButtonState("NORMAL");
	end
	
	if (tab == 1) then
		if (not FSwapper3.FS3GUI:IsShown()) then
			return;
		end
		FSwapper3.FS3GUI_WeaponTab_MainHandText:SetText(FSwapper3.db.char.MainHand or L["|cffff0000[Not Set]|r"]);
		FSwapper3.FS3GUI_WeaponTab_MainHandTip:SetWidth(FSwapper3.FS3GUI_WeaponTab_MainHandText:GetWidth());
		FSwapper3.FS3GUI_WeaponTab_OffHandText:SetText(FSwapper3.db.char.OffHand or L["|cffff0000[Not Set]|r"]);
		FSwapper3.FS3GUI_WeaponTab_OffHandTip:SetWidth(FSwapper3.FS3GUI_WeaponTab_OffHandText:GetWidth());
		FSwapper3.FS3GUI_WeaponTab_PoleText:SetText(FSwapper3.db.char.Pole or L["|cffff0000[Not Set]|r"]);
		FSwapper3.FS3GUI_WeaponTab_PoleTip:SetWidth(FSwapper3.FS3GUI_WeaponTab_PoleText:GetWidth());
	elseif (tab == 2) then
		if (not FSwapper3.FS3GUI:IsShown()) then
			return;
		end
	end
end

-- Weapon Tab GUI Functions
function FSwapper3.FS3GUI_WeaponTab:DoInit()
	local labelheight, tabheight;
	FSwapper3.FS3GUI_WeaponTab:SetFrameStrata("FULLSCREEN_DIALOG");
	FSwapper3.FS3GUI_WeaponTab:SetWidth(350);
	FSwapper3.FS3GUI_WeaponTab:SetBackdrop({
			bgFile="Interface\\DialogFrame\\UI-DialogBox-Background",
			edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
			tile = true, tileSize = 32, edgeSize = 32, 
			insets = { left = 8, right = 8, top = 8, bottom = 8 }
		});
	FSwapper3.FS3GUI_WeaponTab:SetBackdropColor(0,0,0,1);
	FSwapper3.FS3GUI_WeaponTab:EnableMouse();
	FSwapper3.FS3GUI_WeaponTab:SetPoint("TOPLEFT", FSwapper3.FS3GUI, "BOTTOMLEFT", 0, 12);

	FSwapper3.FS3GUI_WeaponTab_MainHandLabel:SetPoint("TOPLEFT", FSwapper3.FS3GUI_WeaponTab, "TOPLEFT", 13, -13);
	FSwapper3.FS3GUI_WeaponTab_MainHandLabel:SetText(MAINHANDSLOT .. ": ");
	FSwapper3.FS3GUI_WeaponTab_MainHandLabel:SetJustifyH("LEFT");

	labelheight = FSwapper3.FS3GUI_WeaponTab_MainHandLabel:GetHeight();
	tabheight = 18 + labelheight;

	FSwapper3.FS3GUI_WeaponTab_MainHandText:SetPoint("TOPLEFT", FSwapper3.FS3GUI_WeaponTab_MainHandLabel, "TOPRIGHT");
	FSwapper3.FS3GUI_WeaponTab_MainHandText:SetPoint("RIGHT", FSwapper3.FS3GUI_WeaponTab, "RIGHT", -13, 0);
	FSwapper3.FS3GUI_WeaponTab_MainHandText:SetHeight(labelheight);
	FSwapper3.FS3GUI_WeaponTab_MainHandText:SetJustifyH("LEFT");
	
	FSwapper3.FS3GUI_WeaponTab_MainHandTip:SetPoint("TopLeft", FSwapper3.FS3GUI_WeaponTab_MainHandText);
	FSwapper3.FS3GUI_WeaponTab_MainHandTip:SetHeight(labelheight);
	FSwapper3.FS3GUI_WeaponTab_MainHandTip:EnableMouse();
	
	FSwapper3.FS3GUI_WeaponTab_MainHandTip:SetScript("OnEnter", function()
			GameTooltip:SetOwner(FSwapper3.FS3GUI_WeaponTab_MainHandTip, "ANCHOR_NONE");
			GameTooltip:SetPoint("TOPLEFT", FSwapper3.FS3GUI_WeaponTab_MainHandTip, "BOTTOMLEFT");
			GameTooltip:ClearLines();
			if (FSwapper3.db.char.MainHand) then
				GameTooltip:SetHyperlink(FSwapper3.db.char.MainHand);
			else
				GameTooltip:AddLine(L["|cffff0000[Not Set]|r"]);
			end
			GameTooltip:Show();
		end);
	FSwapper3.FS3GUI_WeaponTab_MainHandTip:SetScript("OnLeave", function()
			GameTooltip:Hide();
		end);
		
	FSwapper3.FS3GUI_WeaponTab_OffHandLabel:SetPoint("TOPLEFT", FSwapper3.FS3GUI_WeaponTab, "TOPLEFT", 13, -tabheight);
	FSwapper3.FS3GUI_WeaponTab_OffHandLabel:SetText(SECONDARYHANDSLOT .. ": ");
	FSwapper3.FS3GUI_WeaponTab_OffHandLabel:SetJustifyH("LEFT");

	labelheight = FSwapper3.FS3GUI_WeaponTab_OffHandLabel:GetHeight();
	tabheight = tabheight + labelheight + 5;

	FSwapper3.FS3GUI_WeaponTab_OffHandText:SetPoint("TOPLEFT", FSwapper3.FS3GUI_WeaponTab_OffHandLabel, "TOPRIGHT");
	FSwapper3.FS3GUI_WeaponTab_OffHandText:SetPoint("RIGHT", FSwapper3.FS3GUI_WeaponTab, "RIGHT", -13, 0);
	FSwapper3.FS3GUI_WeaponTab_OffHandText:SetHeight(labelheight);
	FSwapper3.FS3GUI_WeaponTab_OffHandText:SetJustifyH("LEFT");
	
	FSwapper3.FS3GUI_WeaponTab_OffHandTip:SetPoint("TopLeft", FSwapper3.FS3GUI_WeaponTab_OffHandText);
	FSwapper3.FS3GUI_WeaponTab_OffHandTip:SetHeight(labelheight);
	FSwapper3.FS3GUI_WeaponTab_OffHandTip:EnableMouse();
	
	FSwapper3.FS3GUI_WeaponTab_OffHandTip:SetScript("OnEnter", function()
			GameTooltip:SetOwner(FSwapper3.FS3GUI_WeaponTab_OffHandTip, "ANCHOR_NONE");
			GameTooltip:SetPoint("TOPLEFT", FSwapper3.FS3GUI_WeaponTab_OffHandTip, "BOTTOMLEFT");
			GameTooltip:ClearLines();
			if (FSwapper3.db.char.OffHand) then
				GameTooltip:SetHyperlink(FSwapper3.db.char.OffHand);
			else
				GameTooltip:AddLine(L["|cffff0000[Not Set]|r"]);
			end
			GameTooltip:Show();
		end);
	FSwapper3.FS3GUI_WeaponTab_MainHandTip:SetScript("OnLeave", function()
			GameTooltip:Hide();
		end);
		
	FSwapper3.FS3GUI_WeaponTab_PoleLabel:SetPoint("TOPLEFT", FSwapper3.FS3GUI_WeaponTab, "TOPLEFT", 13, -tabheight);
	FSwapper3.FS3GUI_WeaponTab_PoleLabel:SetText(FSwapper3.LFISHINGPOLES .. ": ");
	FSwapper3.FS3GUI_WeaponTab_PoleLabel:SetJustifyH("LEFT");

	labelheight = FSwapper3.FS3GUI_WeaponTab_OffHandLabel:GetHeight();
	tabheight = tabheight + labelheight + 5;

	FSwapper3.FS3GUI_WeaponTab_PoleText:SetPoint("TOPLEFT", FSwapper3.FS3GUI_WeaponTab_PoleLabel, "TOPRIGHT");
	FSwapper3.FS3GUI_WeaponTab_PoleText:SetPoint("RIGHT", FSwapper3.FS3GUI_WeaponTab, "RIGHT", -13, 0);
	FSwapper3.FS3GUI_WeaponTab_PoleText:SetHeight(labelheight);
	FSwapper3.FS3GUI_WeaponTab_PoleText:SetJustifyH("LEFT");
	
	FSwapper3.FS3GUI_WeaponTab_PoleTip:SetPoint("TopLeft", FSwapper3.FS3GUI_WeaponTab_PoleText);
	FSwapper3.FS3GUI_WeaponTab_PoleTip:SetHeight(labelheight);
	FSwapper3.FS3GUI_WeaponTab_PoleTip:EnableMouse();
	
	FSwapper3.FS3GUI_WeaponTab_PoleTip:SetScript("OnEnter", function()
			GameTooltip:SetOwner(FSwapper3.FS3GUI_WeaponTab_PoleTip, "ANCHOR_NONE");
			GameTooltip:SetPoint("TOPLEFT", FSwapper3.FS3GUI_WeaponTab_PoleTip, "BOTTOMLEFT");
			GameTooltip:ClearLines();
			if (FSwapper3.db.char.OffHand) then
				GameTooltip:SetHyperlink(FSwapper3.db.char.Pole);
			else
				GameTooltip:AddLine(L["|cffff0000[Not Set]|r"]);
			end
			GameTooltip:Show();
		end);
	FSwapper3.FS3GUI_WeaponTab_MainHandTip:SetScript("OnLeave", function()
			GameTooltip:Hide();
		end);
		
	FSwapper3.FS3GUI_WeaponTab:SetHeight(tabheight + 8);

end

]]