﻿local FSwapper3 = LibStub("AceAddon-3.0"):GetAddon("FSwapper3");
local L = LibStub("AceLocale-3.0"):GetLocale("FSwapper3", true);

local FS3GUI = FSwapper3.FS3GUI;

local TabFrame = FS3GUI.TabFrame;
local WeaponFrame = FS3GUI.SubFrame[1];
local OptionsFrame = FS3GUI.SubFrame[2];
local AutoLootFrame = FS3GUI.SubFrame[3];
local EquipmentFrame = FS3GUI.SubFrame[4];

function AutoLootFrame:DoInit()
	AutoLootFrame.DidInit = true;
	
	AutoLootFrame:SetFrameStrata("DIALOG");
	AutoLootFrame:SetWidth(FS3GUI.Width);
	AutoLootFrame:SetBackdrop({
			bgFile="Interface\\DialogFrame\\UI-DialogBox-Background",
			edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
			tile = true, tileSize = 32, edgeSize = 32, 
			insets = { left = 8, right = 8, top = 8, bottom = 8 }
		});
	AutoLootFrame:SetBackdropColor(0,0,0,1);
	AutoLootFrame:EnableMouse();
	AutoLootFrame:SetPoint("TOPLEFT", TabFrame, "BOTTOMLEFT", 0, 12);
		
	AutoLootFrame.CheckList = {};
	AutoLootFrame.CheckList.TickHeight = 0;
	AutoLootFrame.CheckList.xpos = 13;
	AutoLootFrame.CheckList.ypos = 13;

	AutoLootFrame:AddCheck(AutoLootFrame.CheckList, ENABLE, "Enable");
	
	AutoLootFrame.CheckList.xpos = 13;
	AutoLootFrame.CheckList.ypos = 13 + AutoLootFrame.CheckList.TickHeight + 5;
	
	local color = select(4, GetItemQualityColor(1));
	AutoLootFrame:AddCheck(AutoLootFrame.CheckList, color .. (FSwapper3.LQUEST) .. "|r", "Quest");
	
	AutoLootFrame:AddCheck(AutoLootFrame.CheckList, color .. (FSwapper3.LITEMS[19978] or "Fishing Tournament!") .. "|r", "Contest");
	
	for i = 0, 7 do
		color = select(4, GetItemQualityColor(i));
		local name = getglobal("ITEM_QUALITY" .. i .. "_DESC");
		AutoLootFrame:AddCheck(AutoLootFrame.CheckList, color .. name .. "|r", "Quality" .. i);
	end
	
	AutoLootFrame.CheckList.ypos = AutoLootFrame.CheckList.ypos + AutoLootFrame.CheckList.TickHeight + 5;
	
	AutoLootFrame.iddCoinMaster = AutoLootFrame:CreateFontString("$parent_CoinMaster", "ARTWORK", "GameFontNormal");
	AutoLootFrame.iddCoinMaster:SetPoint("TOPLEFT", AutoLootFrame, "TOPLEFT", 13, -(AutoLootFrame.CheckList.ypos));
	AutoLootFrame.iddCoinMaster:SetWidth(FS3GUI.Width - 26);
	AutoLootFrame.iddCoinMaster:SetJustifyH("CENTER");
	AutoLootFrame.iddCoinMaster:SetText((select(2, GetAchievementInfo(2096))));
	
	AutoLootFrame.CheckList.xpos = 13;
	AutoLootFrame.CheckList.ypos = AutoLootFrame.CheckList.ypos + AutoLootFrame.iddCoinMaster:GetHeight() + 5;
	
	AutoLootFrame:AddCheck(AutoLootFrame.CheckList, (string.gsub(GOLD_AMOUNT, "%%d", "")), "GoldCoin");
	color = select(4, GetItemQualityColor(0));
	AutoLootFrame:AddCheck(AutoLootFrame.CheckList, color .. (string.gsub(SILVER_AMOUNT, "%%d", "")) .. "|r", "SilverCoin");
	color = select(4, GetItemQualityColor(5));
	AutoLootFrame:AddCheck(AutoLootFrame.CheckList, color .. (string.gsub(COPPER_AMOUNT, "%%d", "")) .. "|r", "CopperCoin");
	
	AutoLootFrame.CheckList.ypos = AutoLootFrame.CheckList.ypos + AutoLootFrame.CheckList.TickHeight + 5;
	
	AutoLootFrame:SetHeight(AutoLootFrame.CheckList.ypos + 8);
end

function AutoLootFrame:AddCheck(list, label, value)
	local index = (#list) + 1;
	local linewidth, maxwidth = 0, FS3GUI.Width - 8;
	
	local CheckLine = {};
	CheckLine.Value = value;
	
	CheckLine.Box = CreateFrame("CheckButton", nil, AutoLootFrame, "UICheckButtonTemplate");
	CheckLine.Label = AutoLootFrame:CreateFontString("$parent_AutoLootLabel" .. index,"ARTWORK","GameFontNormal");
	
	CheckLine.Box:SetScript("OnClick", function(self, button)
			if (button == "LeftButton") then
				FSwapper3.db.char.AutoLoot[value] = not FSwapper3.db.char.AutoLoot[value];
				AutoLootFrame:DoUpdate();
			end
		end);
		
	CheckLine.Label:SetText(label);
	CheckLine.Label:SetJustifyH("LEFT");
	
	list[index] = CheckLine;
	
	local boxcy, labelcy = CheckLine.Box:GetHeight(), CheckLine.Label:GetHeight();
	if (list.TickHeight == 0) then
		list.TickHeight = boxcy;
	end
	local shift = (labelcy - boxcy) / 2;
	CheckLine.Label:SetPoint("TOPLEFT", CheckLine.Box, "TOPRIGHT", 0, shift);
	
	linewidth = CheckLine.Box:GetWidth() + CheckLine.Label:GetWidth() + 5;
	if (linewidth + list.xpos > maxwidth) then
		list.xpos, list.ypos = 13, list.ypos + boxcy;
	end
	CheckLine.Box:SetPoint("TOPLEFT", AutoLootFrame, "TOPLEFT", list.xpos, -(list.ypos));
	list.xpos = list.xpos + linewidth;
end

function AutoLootFrame:DoUpdate()
	for i, CheckLine in ipairs(AutoLootFrame.CheckList) do
		CheckLine.Box:SetChecked(FSwapper3.db.char.AutoLoot[CheckLine.Value]);
	end
end